 ###############################################
#                                               #
#   N I C K   C H A N G E   R E S P O N D E R   #
#       v1.07 (11/12/2010) par MenzAgitat       #
#                                               #
#   IRC: irc.epiknet.org  #boulets / #eggdrop   #
#                                               #
#     Mes scripts sont tlchargeables sur      #
#            http://www.eggdrop.fr              #
#                                               #
 ###############################################

#
# Description :
# Le bot ragit aux changements de nick lorsqu'ils contiennent une information
# sur l'activit de la personne.
# Grce  ce script, votre eggdrop vous souhaitera une bonne nuit lorsque
# vous irez vous coucher, vous encouragera quand vous irez travailler, vous
# souhaitera bon apptit quand vous irez manger, etc...
# Il sait dtecter quantit des sparateurs habituellement utiliss dans les
# pseudos, ainsi que beaucoup de faons d'exprimer chaque type d'action.
# Par exemple : nick[dodo], nick|Zzzz, nick``sieste``, nick\dort, nick][sleep][
# seront dtects pareillement.
# Les diffrents types d'action actuellement pris en considration sont :
#		DODO  MIAM  BOULOT  AFK  OQP  JEU  FILM  TELEPHONE  TV  DOUCHE  CINEMA
#		SHOPPING  WC  CUISINE  VAISSELLE  SPORT  MENAGE  PROGRAMMATION  FUME
#		LECTURE MUSIQUE
#	
# Exemple :
#		[ MenzAgitat ] change son nick en [ MenzAgitat[ZZzzZz] ]
#		<Boole> Bonne nuit MenzAgitat.
#
# Pour activer Nick Change Responder sur un chan, vous devez taper en partyline
# .chanset #NomDuChan +NCR
#



#
#	Changelog
#		1.0 	- 1re version
#		1.01	- correction : l'action "pasla" n'tait pas dtecte
#					- l'option interface_megahal tait  1 par dfaut, elle doit tre
#						rgle  0 pour que le script fonctionne dans la plupart des cas.
#		1.02	- correction d'un CTCP ACTION dans les rponses
#						(merci  Ark de l'avoir signal)
#		1.03	- ajouts de quelques nouvelles actions
#					- correction d'un problme de dpendance  l'Interface MegaHAL
#						(merci  Helias de l'avoir signal)
#		1.04	- ajout de quelques nouvelles actions
#					- restructuration du script pour plus de rapidit / volutivit
#						(merci  Artix)
#		1.05	- modification de l'interactivit avec l'Interface MegaHAL
#					- ajout de quelques nouvelles actions
#					- ajout de quelques nouvelles rponses
#		1.06	- restructuration d'une bonne partie du script afin d'offrir plus
#						de convivialit et de modularit pour ajouter/modifier des types
#						d'actions ou des actions (merci  Artix pour les suggestions)
#					- optimisation des regexp
#					- ajout de nouvelles actions
#					- ajout de deux nouveaux types d'action (fume / lecture)
#					- ajout de nouvelles rponses
#		1.07	- correction du namespace de MegaHAL (n'a d'intrt pour vous
#						que si vous utilisez Interface MegaHAL, script du mme auteur)
#					- l'activation/dsactivation du script sur chaque chan se fait
#						maintenant au moyen de la commande .chanset #NomDuChan [+/-]NCR
#						( taper en partyline)
#					- affinage de la dtection, nouveaux sparateurs ajouts
#					- ajout de nouvelles actions
#					- ajout de nouvelles rponses
#					- ajout d'un nouveau type d'action (musique)
#

#
# LICENCE:
#		This program is free software; you can redistribute it and/or modify
#		it under the terms of the GNU General Public License as published by
#		the Free Software Foundation; either version 2 of the License, or
#		(at your option) any later version.
#
#		This program is distributed in the hope that it will be useful,
#		but WITHOUT ANY WARRANTY; without even the implied warranty of
#		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#		GNU General Public License for more details.
#

if {[info commands NCR::uninstall] eq "::NCR::uninstall"} { NCR::uninstall }
# Note pour les programmeurs :
# Dans la version 1.6.19 d'eggdrop, le numro de version affich par .vbottree
# et [numversion] est incorrect; il affiche 1061800 ou 1061801, ce qui
# correspond  la version 1.6.18. On utilise donc une autre technique pour
# vrifier le numro de version.
if { [join [split [string range [lindex $version 0] 0 5] "."] ""] < 1619 } { putloglev o * "\00304\002\[Nick Change Responder - ERREUR\]\002\003 La version de votre eggdrop est \00304\002$version\002\003; \002Nick Change Responder\002 ne fonctionnera correctement que sur les eggdrops version 1.6.19 ou suprieure." ; return }
if { [info tclversion] < 8.5 } { putloglev o * "\00304\002\[Nick Change Responder - ERREUR\]\002\003 \002Nick Change Responder\002 ncessite que Tcl 8.5 (ou plus) soit install pour fonctionner. Votre version actuelle de Tcl est \00304\002$tcl_version\002\003." ; return }
package require Tcl 8.5
namespace eval NCR {


	###########################
	#				PARAMETRES        #
	###########################

	### Ce script est-il destin  fonctionner en collaboration avec l'interface
	# MegaHAL ? (script du mme auteur  tlcharger sparment)
	# (0 = non ; 1 = oui)
	variable interface_megahal 0

	### Types d'action activs
	# (n'y touchez pas  moins de savoir ce que vous faites)
	variable enabledTypes {dodo miam boulot afk oqp jeu film telephone tv douche cinema shopping wc cuisine vaisselle sport menage programmation fume lecture musique}

	### Expressions rgulires utilises pour la dtection des actions dans les nicks
	# (n'y touchez pas si vous n'tes pas familier avec les expressions rgulires)
	array set ::NCR::regexpTypes {
		dodo {^(dodo(?:.*)|zz+|sieste|rest|nap|pion[cs]e|dor[ts]?|s[l1][3e]+p)$}
		miam {^(man[gj]e?|(miam)+|broute|bou(f+|ph)e?|eat(ing)?|rest(o|au)(rant)?)$}
		boulot {^(boulot|ta(f+|ph)e?|travail(le)?|bosse?|revi[sz]e?|devoirs?|etudi?es?|ecole|school|college|lycee|cours|fac)$}
		afk {^(afk|abs(ente?)?|[a4]?w([a4][iy]+)?|p[au]s?_?la|zou|H[SL]|2or|dehors|ailleurs?|off|apu|partie?|revien[st]?)$}
		oqp {^(oqp|dnd|brb|busy|o[cqk]+up(e+|[ae]y))$}
		jeu {^(gam(er?|ing)|j(eu|oue)|pl[a4]y[a4]?)$}
		film {^(div(i?x|idi)|xvid|mkv|f(il|li)m|dvd|movie?)$}
		telephone {^(tel(ephone?)?|(bigo)?(ph|f)one?)$}
		tv {^(t[ei][lv]([ei]|oche?)(vision)?|tv)$}
		douche {^(d[o0]+u?[sc]he?(age)?|bain|baignoire|wash|shower)$}
		cinema {^(cin(e(ma)?|oche?))$}
		shopping {^(courses|shop+(ing|s)?|magasins?(age)?|soldes?)$}
		wc {^([wv]e?ce?s?|[cs]hiot+es?|toil+et+es?|com+ission)$}
		cuisine {^((cu|q\-?)i[zs]ine?|crepes?|gauf+res?)$}
		vaisselle {^(vais+el+e?)$}
		sport {^(sports?|jog+(ing)?|course|escrime|judo|karate|fo+t(bal+)?|baskets?|hand(bal+)?|boxe|danse|equitation|cheval|skis?|rol+ers?|natation|piscine)$}
		menage {^(mena(g|ch)e?|FLMNH|conchita|aspi(rateur)?|net+o(yage|ie?)|range(ment|age))$}
		programmation {^(prog(ram+(ation|e)?)?|cod(e|ing)|c(\++)?|python|tcl|perl|delphi|java(script)?|html|php|css|ajax)$}
		fume {^(fume?|smoke?|(pause[\-_])?(clope?|joint|pet(ard)?|splif+|bedo|ganja|sinse(milia)?))$}
		lecture {^(lect(ure|eur)|li([ts]|vre)|read(ing)?|book|bouquine?|bd)$}
		musique {^((mu)?[sz][ia]+[kq](ue)?|grat+e|guitare?|piano|flute|bat+e?r[iy]e?|violon(cel+e?)?|clarinet+e?|tr[ou]mpet+e?|saxo((ph|f)one?)?|ac+ordeon)$}
	}

	### Bibliothque de rponses aux changements de nick
	# Les variables suivantes sont autorises dans les rponses :
	#		%oldnick = nick prcdent de la personne qui a chang de pseudo
	#		%nick = nouveau nick de la personne qui a chang de pseudo
	#		%randnick = un nick alatoire pris sur le chan (sauf les bots +b)
	#		%nick_root = nick de la personne sans l'action (ex: "Nick" si "Nick[dodo]")
	#		%nick_key = la partie du nick qui a t reconnue (ex: "dodo" si "Nick[dodo]")
	# Vous pouvez galement utiliser des codes de couleur, gras, etc..., ainsi que
	# le CTCP ACTION plus communment connu sous le nom de "/me".
	#
	# -------------------------- DODO
	set ::NCR::replyTypes(dodo) {
		{bonne nuit %nick}
		{dors bien %nick}
		{tch %nick}
		{tchuss %nick}
		{gn8 %nick}
		{bnuit %nick}
		{nenuit %nick}
		{tu vas dormir  cette heure-ci %oldnick ? oO}
		{%oldnick > tu dors tout le temps toi}
		{t'es fatigu de naissance %oldnick}
		{tu vas ENCORE dormir ? oO}
		{tu dors trop %oldnick}
		{\001ACTION change les piles de %oldnick\001}
		{\001ACTION note que %oldnick prsente des signes de faiblesse\001}
		{\001ACTION va border %nick\001}
		{hey attends %oldnick}
		{euh attends 1 seconde %oldnick}
		{attends %oldnick, %randnick voulait te montrer quelque chose}
		{ah attends %nick... euh... non, rien.}
		{commence  chauffer le lit %nick, je te rejoins}
	}
	# -------------------------- MIAM
		set ::NCR::replyTypes(miam) {
		{bon apptit %nick}
		{bon apptit %nick}
		{bon app %nick}
		{bon app %nick}
		{nap %nick}
		{nap %nick}
		{tu passes ton temps  bouffer toi..}
		{%nick > tu vas grossir  force}
		{on mange quoi %nick ?}
		{qu'est-ce qu'on mange %nick ?}
		{ah je me disais bien que j'avais senti un truc brler...}
		{@tte %nick}
		{@+ %nick}
		{a+ %nick}
		{++ %nick}
	}
	# -------------------------- BOULOT
	set ::NCR::replyTypes(boulot) {
		{bon courage %nick}
		{bon courage %nick}
		{courage %nick}
		{courage %nick}
		{bon taf %nick}
		{te fatigue pas trop %oldnick}
		{amuse-toi bien %oldnick \o/}
		{ah y'en a quand mme qui bossent}
		{sans dconner %oldnick, tu bosses des fois ? oO}
		{c'est a, va faire semblant de travailler}
		{bonne chance %nick}
		{ah tu bosses toi au moins, pas comme %randnick ^^}
		{\001ACTION regarde %nick travailler\001}
		{toujours les mmes qui s'amusent}
		{toujours les mmes qui bossent}
	}
	# -------------------------- AFK
	set ::NCR::replyTypes(afk) {
		{@tte %nick}
		{@+ %nick}
		{a+ %nick}
		{++ %nick}
		{hey tu crois aller o comme a %oldnick ?}
		{reviens %oldnick, il n'y a rien dans le monde extrieur}
		{tu t'en vas %oldnick ?}
		{tout fout le camp, mme %oldnick...}
		{(c'est bon %oldnick s'en va, on va pouvoir recommencer)}
		{t'en vas pas %oldnick}
		{t'en vas pas %oldnick, on t'aime bien quand mme}
		{te barre pas %oldnick}
		{reste avec nous %oldnick}
		{tu vas o %oldnick ?}
		{%oldnick > si tu pars maintenant, tu vas manquer le plus intressant}
		{tu devrais rester %oldnick}
		{rho l'autre h, il se barre :/}
		{m'enfin reste %oldnick, je te promets que %randnick ne recommencera plus :s}
		{%oldnick > t'as pas rpondu  la question de %randnick}
		{\001ACTION ligote %oldnick pour qu'il reste\001}
		{\001ACTION retient %oldnick\001}
		{attends %oldnick, %randnick voulait te montrer quelque chose}
		{attends-moi %oldnick, je viens aussi}
		{ah attends %nick... euh... non, rien.}
	}
	# -------------------------- OQP
	set ::NCR::replyTypes(oqp) {
		{tu veux nous faire croire que tu as des occupations dans la vie %oldnick ?}
		{tu fais quoi %nick ?}
		{tu fais quoi %nick ?}
		{tu bricoles quoi %nick ?}
		{tu bricoles quoi %nick ?}
		{%nick > change de main de temps en temps}
		{fais pas semblant d'tre occup...}
		{\001ACTION se demande ce que peut bien faire %oldnick\001}
		{\001ACTION occupe %nick\001}
		{\001ACTION s'occupe de %nick\001}
		{%nick > on t'a enfin trouv une occupation ?}
	}
	# -------------------------- JEU
	set ::NCR::replyTypes(jeu) {
		{toujours les mmes qui s'amusent}
		{tu joues  quoi %nick ?}
		{ quoi tu joues %nick ?}
		{c'est quel jeu %nick ?}
		{c'est quoi le nom de ton jeu %nick ?}
		{bon jeu %nick}
		{bon jeu %nick}
		{bon jeu %nick ^^}
		{bon jeu %nick ^^}
		{amuse-toi bien %oldnick}
		{tu joues trop  WoW quand tu passes ton temps en "%nick"...}
		{tu passes ton temps  jouer toi :s}
		{eh b tu peux l'aimer la vie %nick}
		{t'as vraiment rien d'autre  faire %oldnick ?}
		{t'as vraiment que a  foutre %nick...}
		{t'as rien de mieux  faire %oldnick ?}
	}
	# -------------------------- FILM
	set ::NCR::replyTypes(film) {
		{encore en train de te faire des films %oldnick ?}
		{bon film %nick}
		{bon film %nick}
		{arrte de regarder des films de cul %oldnick}
		{tu regardes quoi %nick ?}
		{c'est quoi ton film %nick ?}
		{c'est quoi le nom de ton film %nick ?}
		{%oldnick > ils meurent tous  la fin du film}
		{%oldnick > laisse-moi deviner, tu regardes un film de vacances tlcharg  la fnac ?}
		{\001ACTION se fait des films avec %oldnick\001}
		{\001ACTION regarde %oldnick regarder son film\001}
	}
	# -------------------------- TELEPHONE
	set ::NCR::replyTypes(telephone) {
		{%oldnick > si c'est Jessica, dis-lui que je ne suis pas l}
		{ah pendant que tu les as au tlphone, dis-leur de se magner avec la camisole, on va pas pouvoir tenir %randnick trs longtemps :/}
		{%oldnick > tu veux nous faire croire que tu as des amis ou quoi ?}
		{\001ACTION a %oldnick au tlphone \o/\001}
		{%nick > c'est qui ?}
		{%nick > tu appelles qui ?}
		{%nick > c'est qui au tlphone ?}
		{tu tlphones  qui %nick ?}
		{%oldnick > ne reste pas 1 heure au tlphone}
	}
	# -------------------------- TV
	set ::NCR::replyTypes(tv) {
		{encore en train de mater des sries  la con %oldnick ?}
		{y'en a vraiment qui s'ennuient...}
		{la tv c'est le mal}
		{tu regardes quoi %nick ?}
		{tu regardes quoi %nick ?}
		{tu mates quoi %nick ?}
		{tu mates quoi %nick ?}
		{%oldnick va s'abrutir devant la tl}
		{bon lavage de cerveau %oldnick}
		{t'as pas des trucs plus intressants  faire %oldnick ?}
		{\001ACTION regarde %oldnick regarder la tv\001}
		{t'arrtes jamais de regarder des films de cul %oldnick ?}
	}
	# -------------------------- DOUCHE
	set ::NCR::replyTypes(douche) {
		{frotte bien partout %oldnick}
		{\001ACTION respire un grand coup\001}
		{je peux venir %oldnick ?}
		{t'avais pas dit que tu ne te lavais plus ?}
		{%oldnick > frotte pas trop longtemps au mme endroit}
		{arrte %oldnick, tu excites %randnick}
		{bonne douche %nick}
		{bonne douche %nick}
		{c'tait donc a cette odeur...}
		{bonne ide %oldnick}
		{comment t'as fait pour te salir %oldnick ?}
		{\001ACTION va prendre une douche avec %oldnick\001}
		{\001ACTION se demande d'o vient cette odeur\001}
		{%oldnick > %randnick n'ose pas te demander mais il voudrait savoir s'il peut venir avec toi}
		{%oldnick va prendre son bain mensuel...}
	}
	# -------------------------- CINEMA
	set ::NCR::replyTypes(cinema) {
		{bon film %nick}
		{bon film %nick}
		{bon cin %nick}
		{bon cin %nick}
		{bon flim %nick}
		{amuse-toi bien %nick}
		{tu vas voir quoi %nick ?}
		{c'est quel film %nick ?}
		{tu vas voir quel film %nick ?}
		{tu y vas avec qui %nick ?}
		{tu nous raconteras %nick ?}
		{%oldnick > euh tu veux pas emmener %randnick avec toi par hasard ?}
	}
	# -------------------------- SHOPPING
	set ::NCR::replyTypes(shopping) {
		{fais pas de folies %oldnick}
		{ils t'ont enfin redonn un chquier %oldnick ?}
		{t'es plus interdit bancaire %oldnick ?}
		{bon shopping %nick}
		{bon shopping %nick}
		{bonnes courses %nick}
		{bonnes courses %nick}
		{tu vas faire du shopping  cette heure-ci ? oO}
		{dis %oldnick, tu veux pas emmener %randnick avec toi des fois ?}
		{%oldnick > pendant que tu y es, tu pourrais pas essayer de te faire rembourser %randnick ? Y'a un vice de fabrication...}
		{%oldnick > tant que tu y es, tu pourrais essayer de te faire changer %randnick ? Je crois qu'il est encore sous garantie...}
		{pense  acheter du pain}
	}
	# -------------------------- WC
	set ::NCR::replyTypes(wc) {
		{t'as vraiment trop la classe %oldnick}
		{c'est vachement intressant %oldnick}
		{c'est super intressant a %oldnick}
		{ce que j'aime chez toi c'est ta finesse %oldnick}
		{ce que j'aime chez toi c'est ta classe %oldnick}
		{tu devrais attendre un peu %oldnick, y'a %randnick qui vient juste d'y aller...}
		{tu retournes passer la 2me couche %oldnick ?}
		{tu vas aux chiottes toutes les 20mn %oldnick, on va finir par s'imaginer des choses...}
		{amis qui tes  table, %oldnick vous souhaite un bon apptit}
		{tire la chasse cette fois %oldnick :/}
		{vite d'en foutre partout comme la dernire fois %oldnick}
		{%oldnick est sponsoris par les drages Fuca}
		{tu vas faire quoi exactement %oldnick ?}
		{tu nous raconteras %oldnick}
		{tu as une vie vachement intressante quand mme %oldnick}
		{dcidment %oldnick, tu vis une vie passionnante !}
		{\001ACTION trouve que %oldnick n'a pas autant la classe que James Bond mais presque\001}
		{attends %oldnick, y'a %randnick qui veut venir avec toi}
		{bon chiotte %oldnick}
		{amuse-toi bien %oldnick}
	}
	# -------------------------- CUISINE
	set ::NCR::replyTypes(cuisine) {
		{eh ben a va tre bon :/}
		{ouch c'est %oldnick qui fait la cuisine :s}
		{tu cuisines quoi %nick ?}
		{tu fais quoi %nick ?}
		{a sent le cram}
		{c'tait donc a cette odeur}
		{a se mange ce que tu fais %oldnick ?}
		{tu arrives  faire des plats comestibles %oldnick ?}
		{tu cuisines un sandwich au pain %oldnick ?}
		{%oldnick fait des expriences...}
		{a sait cuisiner un geek ?}
		{tu veux nous faire croire que tu sais cuisiner %oldnick ?}
		{%oldnick essaie de nous faire croire qu'il sait cuisiner}
		{%oldnick > euh t'es sr que tu veux pas laisser %randnick faire a  ta place ?}
		{merde, %oldnick fait la cuisine :s}
		{hum a vous dit pas d'aller au resto ? c'est %oldnick qui fait la cuisine...}
		{tu fais cuire de l'eau %nick ?}
	}
	# -------------------------- VAISSELLE
	set ::NCR::replyTypes(vaisselle) {
		{amuse-toi bien %nick}
		{ne casse pas tout %nick}
		{bonne vaisselle %nick}
		{bon courage %nick}
		{tu vis vraiment une vie passionnante %oldnick}
		{ne te blesse pas %oldnick}
		{courage %nick}
		{laisse a %oldnick, %randnick va la faire}
		{%randnick > tu veux pas te sortir les doigts et aller donner un coup de main  %oldnick ?}
		{\001ACTION donne discrtement sa vaisselle  %oldnick\001}
	}
	# -------------------------- SPORT
	set ::NCR::replyTypes(sport) {
		{tu vas regarder des vrais sportifs  la tv %oldnick ?}
		{waw %oldnick fait du sport !}
		{vas-y %oldnick, montre-leur !}
		{a fait du sport un geek ? oO}
		{te fais pas mal %nick}
		{te casse rien %nick}
		{te blesse pas %nick}
		{te fatigue pas trop %nick}
		{force pas trop %nick}
		{amuse-toi bien %nick}
		{t'es un winner %oldnick, montre-leur}
		{\001ACTION colle un autocollant Pepsi Cola dans le dos de %oldnick\001}
		{\001ACTION encourage %oldnick\001}
		{\001ACTION se dit que %randnick ferait bien de prendre exemple sur %oldnick, il a pris du bide ces derniers temps...\001}
	}
	# -------------------------- MENAGE
	set ::NCR::replyTypes(menage) {
		{hey y'a %oldnick FLMNH}
		{%nick > tu pourras passer un coup de chiffon sur %randnick aussi stp ? Il prend la poussire.}
		{%nick > tu peux ranger %randnick dans son placard aussi en passant ?}
		{bon mnage %nick}
		{amuse-toi bien %nick}
		{courage %nick}
		{bon courage %nick}
		{%nick > ptet qu'en rangeant tu vas retrouver un pote  toi sous le bordel}
		{\001ACTION donne son linge sale  %nick\001}
		{\001ACTION vide le cendrier par terre en prenant un air dtach\001}
		{balance tout par la fentre %oldnick, t'y verras plus clair}
		{%nick > tu pourras venir ranger chez moi aprs ?}
	}
	# -------------------------- PROGRAMMATION
	set ::NCR::replyTypes(programmation) {
		{tu fais quoi %nick ?}
		{tu fais quoi %nick ?}
		{tu codes quoi %nick ?}
		{tu codes quoi %nick ?}
		{tu programmes quoi %nick ?}
		{tu programmes quoi %nick ?}
		{tu fabriques quoi %nick ?}
		{tu fabriques quoi %nick ?}
		{%oldnick est un h4xx0r et il nous avait cach a :]}
		{trafique pas trop la matrice %oldnick, c'est tout ce qu'on a}
		{ne t'approche pas de moi %oldnick, j'ai pas besoin d'tre bricol}
		{amuse-toi bien %nick}
		{tu rvolutionnes l'informatique %oldnick ?}
		{toujours occup  rvolutionner l'informatique %oldnick ?}
	}
	# -------------------------- FUME
	set ::NCR::replyTypes(fume) {
		{\001ACTION ouvre la fentre\001}
		{\001ACTION tousse\001}
		{\001ACTION donne du feu  %nick\001}
		{\001ACTION met le feu  %nick\001}
		{\001ACTION montre la pancarte "non-fumeur"  %nick\001}
		{\001ACTION crase %nick dans le cendrier\001}
		{%nick > tu fais aussi des pauses boulot des fois ?}
		{%nick > fais tourner}
		{%nick > pas devant les enfants, voyons...}
		{t'as recommenc  fumer %nick ?}
		{encore  fumer des mgots que tu trouves par terre %nick ?}
	}
	# -------------------------- LECTURE
	set ::NCR::replyTypes(lecture) {
		{\001ACTION se demande si %nick pourra lui prter son hentai une fois qu'il l'aura termin\001}
		{\001ACTION lit par dessus l'paule de %nick\001}
		{%nick s'instruit}
		{tu regardes juste les images %nick ?}
		{tu lis quoi %nick ?}
		{qu'est-ce que tu lis %nick ?}
		{%nick > c'est quoi ton bouquin ?}
		{%nick > tu bouquines quoi ?}
		{%nick > a raconte quoi ?}
		{%nick > a parle de quoi ?}
	}
	# -------------------------- MUSIQUE
	set ::NCR::replyTypes(musique) {
		{%nick va encore nous casser les oreilles}
		{\001ACTION met ses boules quies\001}
		{%nick > %nick_key = tu joues ou tu coutes ?}
		{%nick > tu joues pas du triangle toi ?}
		{%nick > tu joues pas du pipeau toi ?}
		{c'est les voisins qui vont tre contents}
		{%nick > tes voisins doivent te dtester  force}
		{%nick va encore nous faire la danse des canards :/}
		{arrte un peu avec ta tecktonik %nick :/}
	}



	###################################
	# Fin de la section configuration #
	###################################
	




####################################################################
#                                                                  #
# NE MODIFIEZ RIEN APRES CE CADRE SI VOUS NE CONNAISSEZ PAS LE TCL #
#                                                                  #
#   DO NOT MODIFY ANYTHING BELOW THIS BOX IF YOU DON'T KNOW TCL    #
#                                                                  #
####################################################################

	variable scriptname "Nick Change Responder"
  variable version "1.07.20101211"
	setudef flag NCR
	proc uninstall {args} {
		putlog "Dsallocation des ressources de \002$NCR::scriptname...\002"
		foreach binding [lsearch -inline -all -regexp [binds *[set ns [string range [namespace current] 2 end]]*] " (::)?$ns"] {
			unbind [lindex $binding 0] [lindex $binding 1] [lindex $binding 2] [lindex $binding 4]
		}
		namespace delete ::NCR
	}
}

# traitement des changements de nick
proc NCR::nickChange {nick host hand chan newnick} {
	if { ![channel get $chan NCR] } { return }
	# Si le bot est en mode "ta gueule" alors il est inutile d'aller plus loin, on interromp.
	if { ($NCR::interface_megahal) && ([info exists megahal_interface::shutup([set clean_chan [megahal_interface::neutralize_special_chars $chan]])]) && ($megahal_interface::shutup($clean_chan)) } {
		return
	}
	if {![regexp {(?:^|(.*?)(?:[\^\]\[`\|_\-\\\{\}\(\)]))(.+?)(?:[\^\]\[`\|_\-\\\{\}\(\)]|$)} $newnick dummy nick_root nick_key]} { return }
		if { $nick_root eq "" } { set nick_root $nick_key }
	set reply ""
	foreach currentType $NCR::enabledTypes { 
		if {[regexp -nocase $NCR::regexpTypes($currentType) $nick_key]} {
			set reply [lindex $NCR::replyTypes($currentType) [rand [llength $NCR::replyTypes($currentType)]]]
			break
		}
	}
	if { $reply ne "" } {
		regsub -all "%oldnick" $reply $nick reply
		# %randnick = nick alatoire ne pouvant ni tre un bot (flag b), ni $nick
		regsub -all "%randnick" $reply [lindex [set nicklist [lreplace [set chanlist_temp [chanlist $chan -b]] [set list_index [lsearch $chanlist_temp [regsub -all {["\]\[\}\{\\]} $newnick "\\\\&"]]] $list_index]] [rand [llength $nicklist]]] reply ; # "
		regsub -all "%nick_key" $reply $nick_key reply
		regsub -all "%nick_root" $reply $nick_root reply
		# laisser ce regsub  la fin car les remplacements prcdents contiennent aussi %nick
		regsub -all "%nick" $reply $newnick reply
		# neutralisation des antislashes (sauf codes de contrle \001 \002 \003 \022 \037 \017
		regsub -all {(?!\\001|\\002|\\003|\\022|\\037|\\017)(\\)} $reply "\\\\\\\\" reply
		set reply [join $reply]
		if { $NCR::interface_megahal } {
			::megahal_interface::talk $chan [::megahal_interface::neutralize_special_chars $chan] $newnick [::megahal_interface::neutralize_special_chars $newnick] "external" $reply
		} else {
			puthelp "PRIVMSG $chan :$reply" -next
			# on crit dans le log du chan ce que dit le bot car le logger interne ne le fait pas
			putloglev p $chan "<$::botnick> $reply"
		}
	}
	return
}

# binds
bind nick - * NCR::nickChange
bind evnt - prerehash NCR::uninstall


putlog "\002$NCR::scriptname v$NCR::version\002 (2010 MenzAgitat) a t charg."
